diff --git a/SUPPORT.md b/SUPPORT.md
index 9478b70b1b..019b49157e 100644
--- a/SUPPORT.md
+++ b/SUPPORT.md
@@ -453,7 +453,7 @@ A periodically repeating fixed timeslice scheduler.
 
     Status: Supported
 
-Currently only single-vcpu domains are supported.
+Currently, only single-vcpu domains are supported.
 
 ### Null Scheduler
 
diff --git a/docs/designs/non-cooperative-migration.md b/docs/designs/non-cooperative-migration.md
index 54496892ed..28c9301748 100644
--- a/docs/designs/non-cooperative-migration.md
+++ b/docs/designs/non-cooperative-migration.md
@@ -124,7 +124,7 @@ nodes.
 Because the console and store protocol shared pages are actually part of
 the guest memory image (in an E820 reserved region just below 4G in x86
 VMs) then the content will get migrated as part of the guest memory image.
-Hence no additional code is require to prevent any guest visible change in
+Hence, no additional code is required to prevent any guest visible change in
 the content.
 
 ### Shared Info
@@ -189,7 +189,7 @@ this fashion frontend and backend drivers can use the event channel as a
 *mailbox* to notify each other when a shared ring has been updated with new
 requests or response structures.
 
-Currently no event channel state is preserved on migration, requiring
+Currently, no event channel state is preserved on migration, requiring
 frontend and backend drivers to create and bind a complete new set of event
 channels in order to re-establish a protocol connection. Hence, one or more
 new save records will be required to transfer event channel state in order
@@ -222,12 +222,12 @@ The guest is responsible for managing its own grant table. No hypercall is
 required to grant a memory page to another domain. It is sufficient to find
 an unused grant entry and set bits in the entry to give read and/or write
 access to a remote domain also specified in the entry along with the page
-frame number. Thus the layout and content of the grant table logically
+frame number. Thus, the layout and content of the grant table logically
 forms part of the guest state.
 
-Currently no grant table state is migrated, requiring a guest to separately
+Currently, no grant table state is migrated, requiring a guest to separately
 maintain any state that it wishes to persist elsewhere in its memory image
-and then restore it after migration. Thus to avoid the need for such
+and then restore it after migration. Thus, to avoid the need for such
 explicit action by the guest, one or more new save records will be required
 to migrate the contents of the grant table.
 
diff --git a/docs/designs/qemu-deprivilege.md b/docs/designs/qemu-deprivilege.md
index 3be33adf6a..97ad35ec0e 100644
--- a/docs/designs/qemu-deprivilege.md
+++ b/docs/designs/qemu-deprivilege.md
@@ -179,7 +179,7 @@ being killed by the target process:
             kill(-1, 9);
     }
 
-Fortunately there is an assymetry we can take advantage of.  From the
+Fortunately, there is an asymmetry we can take advantage of.  From the
 POSIX spec:
 
 > For a process to have permission to send a signal to a process
@@ -269,7 +269,7 @@ environments.  We therefore need to either:
 The chroot (and seccomp?) happens late enough such that QEMU can
 initialize itself and open its disks. If you want to add a disk at run
 time via or insert a CD, you can't pass a path because QEMU is
-chrooted. Instead use the add-fd QMP command and use
+chrooted. Instead, use the add-fd QMP command and use
 /dev/fdset/<fdset-id> as the path.
 
 A further layer of restriction could be to set RLIMIT_NOFILES to '0',
diff --git a/docs/designs/xenstore-migration.md b/docs/designs/xenstore-migration.md
index 082314bf72..824aed9557 100644
--- a/docs/designs/xenstore-migration.md
+++ b/docs/designs/xenstore-migration.md
@@ -140,7 +140,7 @@ xenstored state that needs to be restored.
 | `evtchn-fd`    | The file descriptor used to communicate with |
 |                | the event channel driver                     |
 
-xenstored will resume in the original process context. Hence `rw-socket-fd`
+xenstored will resume in the original process context. Hence, `rw-socket-fd`
 simply specifies the file descriptor of the socket. Sockets are not always
 used, however, and so -1 will be used to denote an unused socket.
 
@@ -245,7 +245,7 @@ For `socket` connections it is as follows:
 | `socket-fd` | The file descriptor of the connected socket     |
 
 This type of connection is only relevant for live update, where the xenstored
-resumes in the original process context. Hence `socket-fd` simply specify
+resumes in the original process context. Hence, `socket-fd` simply specify
 the file descriptor of the socket connection.
 
 \pagebreak
diff --git a/docs/man/xl.cfg.5.pod.in b/docs/man/xl.cfg.5.pod.in
index 8e1422104e..e3cb930cef 100644
--- a/docs/man/xl.cfg.5.pod.in
+++ b/docs/man/xl.cfg.5.pod.in
@@ -506,7 +506,7 @@ Load the specified file as firmware for the guest.
 
 =head4 PVH guest options
 
-Currently there's no firmware available for PVH guests, they should be
+Currently, there's no firmware available for PVH guests, they should be
 booted using the B<Direct Kernel Boot> method or the B<bootloader> option.
 
 =over 4
diff --git a/docs/misc/cache-coloring.rst b/docs/misc/cache-coloring.rst
index e156062aa2..022ed1f3da 100644
--- a/docs/misc/cache-coloring.rst
+++ b/docs/misc/cache-coloring.rst
@@ -4,7 +4,7 @@ Xen cache coloring user guide
 =============================
 
 The cache coloring support in Xen allows to reserve Last Level Cache (LLC)
-partitions for Dom0, DomUs and Xen itself. Currently only ARM64 is supported.
+partitions for Dom0, DomUs and Xen itself. Currently, only ARM64 is supported.
 Cache coloring realizes per-set cache partitioning in software and is applicable
 to shared LLCs as implemented in Cortex-A53, Cortex-A72 and similar CPUs.
 